---
title: InputEvent.getTargetRanges()
slug: Web/API/InputEvent/getTargetRanges
tags:
  - API
  - DOM Events
  - Input
  - InputEvent
  - Method
  - Reference
  - events
  - getTargetRanges()
---
<p>{{APIRef("DOM Events")}}</p>

<p>The <strong><code>getTargetRanges()</code></strong> method of the {{domxref("InputEvent")}} interface returns an array of static ranges that will be affected by a change to the DOM if the input event is not canceled.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">var <em>staticRanges</em>[] = <em>inputEvent</em>.getTargetRanges()</pre>

<h3 id="Parameters">Parameters</h3>

<p>None.</p>

<h3 id="Return_value">Return value</h3>

<p>An array of {{domxref("StaticRange")}} objects.</p>

<h2 id="Examples">Examples</h2>

<h3 id="Feature_Detection">Feature Detection</h3>

<p>The following function returns true if <code>beforeinput</code>, and thus <code>getTargetRanges</code>, is supported.</p>

<pre class="brush: js notranslate">function isBeforeInputEventAvailable() {
  return window.InputEvent && typeof InputEvent.prototype.getTargetRanges === "function";
}
</pre>

<h3 id="Basic_usage">Basic usage</h3>

<p>The following example selects a <code>contenteditable</code> element and utilises the <code><a href="/en-US/docs/Web/API/HTMLElement/beforeinput_event">beforeinput</a></code> event to log the result of <code>getTargetRanges()</code>.</p>

<pre class="brush: js notranslate">const editableElem = document.querySelector('[contenteditable="true"]');

editableElem.addEventListener('beforeinput', (e) =&gt; {
    const targetRanges = e.getTargetRanges();
    console.log(targetRanges);
})
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('InputEvents2','#dom-inputevent-gettargetranges','getTargetRanges()')}}</td>
   <td>{{Spec2('InputEvents2')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_Compatibility">Browser Compatibility</h2>

<div>

<p>{{Compat("api.InputEvent.getTargetRanges")}}</p>
</div>
